# CHANGELOG

*We intend to follow [Semantic Versioning 2.0.0](https://semver.org/), if you
find a change that break's semver, please create an issue.*

## [v2.4.0](https://github.com/knplabs/knptimebundle/releases/tag/v2.4.0)

*June 11th, 2024*

### Feature

- [#215](https://github.com/KnpLabs/KnpTimeBundle/pull/215) [translations] add additional Czech time translations - *@analogic*


## [v2.3.0](https://github.com/knplabs/knptimebundle/releases/tag/v2.3.0)

*June 6th, 2024*

### Feature

- [#209](https://github.com/KnpLabs/KnpTimeBundle/pull/209) [translation] add additional Slovak translations - *@tito10047*

## [v2.0.0]

- Modernize/simplify the code base
- Require PHP 8.1+
- Remove `symfony/templating` integration
- Make `DateTimeFormatter` final
- Remove `DateTimeFormatter::getDiffMessage()`
- Remove `DateTimeFormatter::getDateTimeObject()`
- Remove `DateTimeFormatter::getEmptyDiffMessage()`
- Add `time_diff` Twig filter as an alias for `ago`
- Add `DateTimeFormatter::formatDuration()` and `duration` Twig filter 

## [v1.20.0](https://github.com/knplabs/knptimebundle/releases/tag/v1.20.0)

*October 11th, 2022*

### Feature

- [#172](https://github.com/knplabs/knptimebundle/pull/172) - drop symfony 4.4 support - *@jrushlow*

## [v1.19.0](https://github.com/knplabs/knptimebundle/releases/tag/v1.19.0)

*May 10th, 2022*

### Feature

- [#169](https://github.com/knplabs/knptimebundle/pull/169) - [DX] Make "to" argument optional - *@weaverryan*

## [v1.18.0](https://github.com/knplabs/knptimebundle/releases/tag/v1.18.0)

*February 7th, 2022*

### Feature

- [#164](https://github.com/knplabs/knptimebundle/pull/164) - Force DateTime constructor parameter (PHP 8.1 deprecation) - *@grosmanal*

## [1.17.0](https://github.com/knplabs/knptimebundle/releases/tag/1.17.0)

*October 28th, 2021*

### Feature

- [#162](https://github.com/knplabs/knptimebundle/pull/162) - add return types for symfony 6 support - *@jrushlow*
- [#161](https://github.com/knplabs/knptimebundle/pull/161) - Allow Symfony 6 - *@Kocal*

## [v1.16.1](https://github.com/knplabs/knptimebundle/releases/tag/v1.16.1)

*July 13th, 2021*

### Bug Fix

- [#158](https://github.com/knplabs/knptimebundle/pull/158) - Fixed strange construction "za dzień" to "jutro" - *@KerbenII*

## [v1.16.0](https://github.com/knplabs/knptimebundle/releases/tag/v1.16.0)

*March 2nd, 2021*

### Feature

- [#156](https://github.com/knplabs/knptimebundle/pull/156) - change CI and bump supported versions - *@jrushlow*

## [v1.15.0](https://github.com/knplabs/knptimebundle/releases/tag/v1.15.0)

*January 15th, 2021*

### Feature

- [#150](https://github.com/knplabs/knptimebundle/pull/150) - Added Norwegian bokmål and Norwegian nynorsk translations - *@jon-harald*
- [#152](https://github.com/knplabs/knptimebundle/pull/152) - added the locale parameter - *@jpgiroux*
- [#153](https://github.com/knplabs/knptimebundle/pull/153) - implement PHP's type system - *@jrushlow*

## [v1.14.0](https://github.com/knplabs/knptimebundle/releases/tag/v1.14.0)

*December 16th, 2020*

### Feature

- [#147](https://github.com/knplabs/knptimebundle/pull/147) - Add compatibility for PHP 8.0 - *@m-vo*

## [v1.13.0](https://github.com/knplabs/knptimebundle/releases/tag/v1.13.0)

*August 14th, 2020*

### Feature

- [#141](https://github.com/knplabs/knptimebundle/pull/141) - Remove symfony/templating as a hard dependency - *@kbond*

## [v1.12.0](https://github.com/knplabs/knptimebundle/releases/tag/v1.12.0)

*July 7th, 2020*

### Feature

- [#136](https://github.com/knplabs/knptimebundle/pull/136) - Add thai translations - *@Seb33300*
- [#137](https://github.com/knplabs/knptimebundle/pull/137) - Add bg translation - *@ggabrovski*
- [#138](https://github.com/knplabs/knptimebundle/pull/138) - Migrate to PSR-4 - *@mhor*

### Bug Fix

- [#109](https://github.com/knplabs/knptimebundle/pull/109) - Fixed Serbian translation - *@ljubar*

## [v1.11.0](https://github.com/knplabs/knptimebundle/releases/tag/v1.11.0)

*December 30th, 2019*

### Feature

- [#127](https://github.com/knplabs/knptimebundle/pull/127) - use namespaced twig classes - *@zaggi-iwnl*
- [#129](https://github.com/knplabs/knptimebundle/pull/129) - bumping php & symfony version dependencies and making code updates - *@weaverryan*

## [v1.10.0](https://github.com/knplabs/knptimebundle/releases/tag/v1.10.0)

*December 5th, 2019*

### Feature

- [#123](https://github.com/knplabs/knptimebundle/pull/123) - removing support for most obsolete versions - *@weaverryan*
- [#121](https://github.com/knplabs/knptimebundle/pull/121) - Allow Symfony 5 - *@tacman*

## [v1.9.1](https://github.com/knplabs/knptimebundle/releases/tag/v1.9.1)

*April 19th, 2019*

### Feature

- [#117](https://github.com/knplabs/knptimebundle/pull/117) - Use transChoice for Symfony <4.2 - *@cb8*

## [1.9.0](https://github.com/knplabs/knptimebundle/releases/tag/1.9.0)

*December 19th, 2018*

### Bug Fix

- [#111](https://github.com/knplabs/knptimebundle/pull/111) - Fix symfony 4.2 transChoice deprecation - *@dirkkredler*

## [1.8.0](https://github.com/knplabs/knptimebundle/releases/tag/1.8.0)

*December 26th, 2017*

### Feature

- [#103](https://github.com/knplabs/knptimebundle/pull/103) - [#SymfonyConHackday2017] SF4 compatibility update - *@michalkurzeja*

## [1.7.5](https://github.com/knplabs/knptimebundle/releases/tag/1.7.5)

*October 27th, 2017*

### Bug Fix

- [#101](https://github.com/knplabs/knptimebundle/pull/101) - Fix romanian translation of minute (singular) - *@sergiu-popa*

## [1.7.4](https://github.com/knplabs/knptimebundle/releases/tag/1.7.4)

*July 12th, 2017*

### Feature

- [#97](https://github.com/knplabs/knptimebundle/pull/97) - Add Slovak translation - *@dfridrich*

## [1.7.3](https://github.com/knplabs/knptimebundle/releases/tag/1.7.3)

*March 4th, 2017*

### Feature

- [#94](https://github.com/knplabs/knptimebundle/pull/94) - added Esperanto translation - *@marcu87*

## [1.7.2](https://github.com/knplabs/knptimebundle/releases/tag/1.7.2)

*February 2nd, 2017*

### Bug Fix

- [#92](https://github.com/knplabs/knptimebundle/pull/92) - Turkish translation bug fixed - *@shibby*

## [1.7.1](https://github.com/knplabs/knptimebundle/releases/tag/1.7.1)

*January 20th, 2017*

### Feature

- [#91](https://github.com/knplabs/knptimebundle/pull/91) - NewFeature: Catalan Translations - *@aleixfargas*

## [1.7.0](https://github.com/knplabs/knptimebundle/releases/tag/1.7.0)

*October 22nd, 2016*

### Feature

- [#87](https://github.com/knplabs/knptimebundle/pull/87) - Add DateTimeImmutable support - *@Einenlum*
- [#88](https://github.com/knplabs/knptimebundle/pull/88) - Add Finnish language translations - *@nicodemuz*

### Bug Fix

- [#89](https://github.com/knplabs/knptimebundle/pull/89) - Fix Polish Translations Pluralization - *@pawelabrams*

## [1.6.1](https://github.com/knplabs/knptimebundle/releases/tag/1.6.1)

*May 10th, 2016*

### Feature

- [#82](https://github.com/knplabs/knptimebundle/pull/82) - Added Kyrgyz translation - *@imanalopher*
- [#76](https://github.com/knplabs/knptimebundle/pull/76) - add some Turkish related translations - *@behram*

## [1.6.0](https://github.com/knplabs/knptimebundle/releases/tag/1.6.0)

*April 22nd, 2016*

### Feature

- [#75](https://github.com/knplabs/knptimebundle/pull/75) - add translation for vietnamese - *@dchien234*

### Bug Fix

- [#80](https://github.com/knplabs/knptimebundle/pull/80) - Fix the german translation - *@leofeyer*
- [#81](https://github.com/knplabs/knptimebundle/pull/81) - Fix typo in time.uk.xliff - *@relo-san*
- [#79](https://github.com/knplabs/knptimebundle/pull/79) - Fix czech translation - *@dfridrich*

## [1.5.3](https://github.com/knplabs/knptimebundle/releases/tag/1.5.3)

*November 24th, 2015*

### Bug Fix

- [#73](https://github.com/knplabs/knptimebundle/pull/73) - Bug with showing time, ending on 1. - *@relo-san*

## [1.5.2](https://github.com/knplabs/knptimebundle/releases/tag/1.5.2)

*November 12th, 2015*

### Feature

- [#71](https://github.com/knplabs/knptimebundle/pull/71) - Symfony 3 support - *@akovalyov*

## [1.5.1](https://github.com/knplabs/knptimebundle/releases/tag/1.5.1)

*November 11th, 2015*

### Bug Fix

- [#65](https://github.com/knplabs/knptimebundle/pull/65) - correcting translations sr_Latn - *@cvele*

## [1.5.0](https://github.com/knplabs/knptimebundle/releases/tag/1.5.0)

*October 7th, 2015*

### Feature

- [#68](https://github.com/knplabs/knptimebundle/pull/68) - Updates twig extension to work with twig 1.12-2.0 - *@bryanagee*

## [1.4.0](https://github.com/knplabs/knptimebundle/releases/tag/1.4.0)

*September 17th, 2015*

### Feature

- [#54](https://github.com/knplabs/knptimebundle/pull/54) - Added PT translations - *@fixe*
- [#55](https://github.com/knplabs/knptimebundle/pull/55) - Added romanian translations - *@ghost*
- [#61](https://github.com/knplabs/knptimebundle/pull/61) - Adding serbian latin translation - *@cvele*
- [#57](https://github.com/knplabs/knptimebundle/pull/57) - Add hungarian translation - *@dhargitai*
- [#62](https://github.com/knplabs/knptimebundle/pull/62) - Add Indonesian translation - *@egig*
- [#58](https://github.com/knplabs/knptimebundle/pull/58) - Added Lithuanian translation - *@flarelt*
- [#59](https://github.com/knplabs/knptimebundle/pull/59) - Add Arabic Localization strings - *@omarahm*

### Bug Fix

- [#63](https://github.com/knplabs/knptimebundle/pull/63) - Revert "Adding serbian latin translation" - *@umpirsky*

## [v1.3](https://github.com/knplabs/knptimebundle/releases/tag/v1.3)

*December 12th, 2013*

### Feature

- [#46](https://github.com/knplabs/knptimebundle/pull/46) - Adding Czech translation - *@deep9*
- [#43](https://github.com/knplabs/knptimebundle/pull/43) - Added Japanese translation - *@nurikabe*

### Bug Fix

- [#47](https://github.com/knplabs/knptimebundle/pull/47) - Update time.ru.xliff - *@sergeylunev*

## [v1.2](https://github.com/knplabs/knptimebundle/releases/tag/v1.2)

*November 15th, 2013*

### Feature

- [#35](https://github.com/knplabs/knptimebundle/pull/35) - Add Ukrainian translations - *@dxops*
- [#12](https://github.com/knplabs/knptimebundle/pull/12) - Twig ago filter - *@docteurklein*
- [#26](https://github.com/knplabs/knptimebundle/pull/26) - Added Basque translations - *@eillarra*
- [#4](https://github.com/knplabs/knptimebundle/pull/4) - Italian Translation - *@ephp*
- [#13](https://github.com/knplabs/knptimebundle/pull/13) - Polish messages translation - *@canni*
- [#11](https://github.com/knplabs/knptimebundle/pull/11) - fix translations with choices - *@docteurklein*
- [#39](https://github.com/knplabs/knptimebundle/pull/39) - Added Swedish translations - *@JhonnyL*
- [#6](https://github.com/knplabs/knptimebundle/pull/6) - Added Chinese translation - *@khepin*
- [#7](https://github.com/knplabs/knptimebundle/pull/7) - Added Spanish translation - *@ejosvp*
- [#9](https://github.com/knplabs/knptimebundle/pull/9) - Russian translation file - *@dr-fozzy*
- [#34](https://github.com/knplabs/knptimebundle/pull/34) - Add ukrainian translations - *@dxops*
- [#21](https://github.com/knplabs/knptimebundle/pull/21) - Added Danish translation. - *@phidah*
- [#48](https://github.com/knplabs/knptimebundle/pull/48) - Add symfony 2.3 support - *@labs-scnm*
- [#17](https://github.com/knplabs/knptimebundle/pull/17) - Added an upper bound on the composer constraint - *@stof*
- [#14](https://github.com/knplabs/knptimebundle/pull/14) - Added Dutch translations - *@itavero*
- [#2](https://github.com/knplabs/knptimebundle/pull/2) - Add german translation file - *@gimler*
- [#33](https://github.com/knplabs/knptimebundle/pull/33) - Add symfony 2.2 support - *@pilot*
- [#40](https://github.com/knplabs/knptimebundle/pull/40) - Added Brazilian Portuguese translation - *@raphox*
- [#5](https://github.com/knplabs/knptimebundle/pull/5) - Add composer.json - *@stloyd*

### Bug Fix

- [#36](https://github.com/knplabs/knptimebundle/pull/36) - fixed wrong translation keys - *@inmarelibero*
- [#41](https://github.com/knplabs/knptimebundle/pull/41) - Fix Chinese Translation - *@luiges90*
- [#3](https://github.com/knplabs/knptimebundle/pull/3) - Fix empty message translation - *@gimler*
- [#37](https://github.com/knplabs/knptimebundle/pull/37) - Fix chinese translation - *@luiges90*
- [#20](https://github.com/knplabs/knptimebundle/pull/20) - Fixed a typo in the Dutch translation. - *@itavero*
- [#31](https://github.com/knplabs/knptimebundle/pull/31) - Update Resources/translations/time.nl.xliff - *@sstok*
- [#23](https://github.com/knplabs/knptimebundle/pull/23) - Fixed plurals in Polish translation - *@kolah*

## [v0.0.0](https://github.com/knplabs/knptimebundle/releases/tag/v0.0.0)

*January 1st, 1900*

### Feature

- [#30](https://github.com/knplabs/knptimebundle/pull/30) - Proposal, raise Symfony dependency - *@michelsalib*
- [#24](https://github.com/knplabs/knptimebundle/pull/24) - Added Danish translation - *@bmatzner*
